import { RJLog } from "../library/RJLog";

export type VariationDefinition = { [index:string]:string[] };
export type VariationDefinitions = VariationDefinition[];

export class VariationTemplates
{
  static readonly genericOnlyIntNode:VariationDefinitions =
  [
    { 
      "{DataTypeName}":[ "Int" ],
      "{DataType}":    [ "int" ],
      "{Extension}":   [ "" ],
      "{ParentClass}":   [ "Node" ]

    }
  ];

  static readonly generic:VariationDefinitions =
  [
    { 
      "{DataTypeName}":[ "Bool", "Float", "Int", "Color", "Vector2", "Vector3", "Quaternion", "String", "Node", "Resource" ],
      "{DataType}":    [ "bool", "float", "int", "Color", "Vector2", "Vector3", "Quaternion", "String", "Ref<Node>", "Ref<Resource>" ] 
    },

    {
      "{Extension}":   [     "", "Global" ],
      "{ParentClass}": [ "Node", "Resource" ]
    }
  ];
}