import { Member } from "../members/Member";
import { BaseFactory } from "./BaseFactory";

export class ActionFactory extends BaseFactory
{
  static readonly regex = /^\s*action\s+(\w+)\s*$/;

  constructor(){ super( ActionFactory.regex ); }

  create( accessModifier:string, nameDefinition:string, memberData:any, members:Member[] )
  {
    let name = ActionFactory.regex.exec( nameDefinition )[ 1 ];
    let upperCaseName = name[ 0 ].toUpperCase() + name.substring( 1 );
    let actionName = `on${upperCaseName}`;

    let signal = `signal ${name}()`;

    members.push( this.createMember( accessModifier, signal, {} ) );
    members.push( this.createMember( accessModifier, actionName, "Node<RJAction>" ) );
  }
}
